using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using NationalInstruments.VisaNS;

namespace sample1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string showstr;
            string responseString;
            int i = -1;
            long cnt = 0;
            MessageBasedSession mbSession;
            //
            // Set the device filter condition for FindResource command
            // The M3500A USB type VID::PID --> 0x164E::0x0DAD  
            //
            try
            {
                cnt = ResourceManager.GetLocalManager().FindResources("USB0::0x164E::0x0DAD::?*").Length;
            }
            catch (Exception ex)
            {
                System.Windows.Forms.MessageBox.Show(ex.Message, "M3500A sample1");
                listBox1.Items.Clear();
                return;
            }

            string[] resources = ResourceManager.GetLocalManager().FindResources("USB0::0x164E::0x0DAD::?*");

            listBox1.Items.Clear();
            cnt = 0;
            foreach (string s in resources)
            {
                cnt = cnt + 1;
            }

            showstr = "The M3500A devices found : ";
            responseString = cnt.ToString();
            i = showstr.Length;
            showstr = showstr.Insert(i, responseString);
            listBox1.Items.Add(showstr);
            listBox1.Items.Add("--------------------------------------------");

            foreach (string s in resources)
            {
                mbSession = (MessageBasedSession)ResourceManager.GetLocalManager().Open(s);

                mbSession.Write("*idn?");
                responseString = mbSession.ReadString();
                listBox1.Items.Add(responseString);
                // Set the M3500A to local mode
                mbSession.Write("system:local");
                mbSession.Dispose();
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            string showstr;
            string responseString;
            int i = -1;
            int cnt = 0;
            MessageBasedSession mbSession;
            //
            // Set the device filter condition for FindResource command
            // The M3500A USB type VID::PID --> 0x164E::0x0DAD  
            //
            try
            {
                cnt = ResourceManager.GetLocalManager().FindResources("USB0::0x164E::0x0DAD::?*").Length;
            }
            catch (Exception ex)
            {
                System.Windows.Forms.MessageBox.Show(ex.Message, "M3500A sample1");
                listBox1.Items.Clear();
                return;
            }

            string[] resources = ResourceManager.GetLocalManager().FindResources("USB0::0x164E::0x0DAD::?*");

            listBox1.Items.Clear();
            cnt = 0;
            foreach (string s in resources)
            {
                cnt = cnt + 1;
            }

            showstr = "The M3500A devices found : ";
            responseString = cnt.ToString();
            i = showstr.Length;
            showstr = showstr.Insert(i, responseString);
            listBox1.Items.Add(showstr);
            listBox1.Items.Add("--------------------------------------------");

            foreach (string s in resources)
            {
                mbSession = (MessageBasedSession)ResourceManager.GetLocalManager().Open(s);
                listBox1.Items.Add(s);
                // Configure the M3500A function Voltage DC, Range 1
                mbSession.Write("CONF:VOLT:DC");
                // Reference  -- configure commands
                // CONF:VOLT:AC      // Set M3500A Voltage AC
                // CONF:CURR:DC      // Set M3500A Current DC
                // CONF:CURR:AC      // Set M3500A Current AC
                // CONF:RES          // Set M3500A 2-Wire Resistance
                // CONF:FRES         // Set M3500A 4-Wire Resistance
                // CONF:FREQ         // Set M3500A Frequency
                // CONF:PER          // Set M3500A Period

                mbSession.Write("TRIG:DELAY 0");
                mbSession.Write("SENS:ZERO:AUTO OFF");
                mbSession.Write("SENS:GAIN:AUTO OFF");
                mbSession.Write("SENS:VOLT:DC:RANGE 1");
                // Set the M3500A to local mode
                mbSession.Write("system:local");
                mbSession.Dispose();
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Boolean sw;
            string devdesc;
            string showstr;
            string responseString;
            int i = -1;
            int cnt;
            MessageBasedSession mbSession;
            //
            // Search all the device "?*" for FindResource command
            //
            string[] resources = ResourceManager.GetLocalManager().FindResources("?*");

            listBox1.Items.Clear();
            sw = true;
            cnt = 0;
            foreach (string s in resources)
            {
                // Filter the resources array for the device M3500
                // The M3500A USB type VID::PID --> 0x164E::0x0DAD 
                i = s.IndexOf("USB0::0x164E::0x0DAD");
                if (i > -1)
                {
                    devdesc = s;
                    cnt = cnt + 1;
                    sw = false;
                }
            }
            if (sw)
            {
                System.Windows.Forms.MessageBox.Show("M3500A device not found.", "M3500A sample1");
                return;
            }
            showstr = "The M3500A devices found : ";
            responseString = cnt.ToString();
            i = showstr.Length;
            showstr = showstr.Insert(i, responseString);
            listBox1.Items.Add(showstr);
            listBox1.Items.Add("--------------------------------------------");

            foreach (string s in resources)
            {
                i = s.IndexOf("USB0::0x164E::0x0DAD");
                if (i > -1)
                {
                    mbSession = (MessageBasedSession)ResourceManager.GetLocalManager().Open(s);
                    listBox1.Items.Add(s);
                    // Configure the M3500A function Voltage DC, Range 1
                    mbSession.Write("CONF:VOLT:DC");
                    mbSession.Write("SENS:VOLT:DC:RANGE:AUTO ON");
                    listBox1.Items.Add("10 times reading\n");
                    for (int j = 0; j < 10; j++)
                    {
                        mbSession.Write("read?");
                        responseString = mbSession.ReadString();
                        responseString = " -->  " + responseString;
                        listBox1.Items.Add(responseString);
                    }
                    // Set the M3500A to local mode
                    mbSession.Write("system:local");
                    mbSession.Dispose();
                }
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }
        
    }
}